/**************************************************************************
 *               This file is part of the FOX Dialog Editor               * 
 *                                                                        * 
 *      Copyright (C) 1999-2000 Martin Welch <mwelch@totalise.co.uk>      *
 *                                                                        * 
 *  This program is free software; you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *                  (at your option) any later version.                   *
 *                                                                        * 
 *    This program is distributed in the hope that it will be useful,     *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *             GNU General Public License for more details.               *
 *                                                                        * 
 *   You should have received a copy of the GNU General Public License    *
 *      along with this program; if not, write to the Free Software       *
 *       Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 **************************************************************************/

#ifndef __CApp_H__
#define __CApp_H__

class CApp : public FXApp
{
	FXDECLARE(CApp)

// Services
public:
	CApp(const FXchar *name="Application",const FXchar *vendor="Default");
	virtual ~CApp();

// Events
protected:
#ifndef WIN32
	virtual void dispatchEvent(FXRawEvent& ev);
#else
	long dispatchEvent(FXID hwnd,unsigned int iMsg,unsigned int wParam,long lParam);
#endif

// Operations
public:
	void allowDelete(void) {m_bAllowDelete = TRUE;}
	void preventDelete(void) {m_bAllowDelete = FALSE;}

	FXbool isCtrlPressed(void) {return m_bCtrlPressed;}

protected:
	virtual FXbool isValidWidget(FXWindow* wnd) {return false;}

	virtual void doResetAction(void) {}

	virtual void doPaint(FXWindow* window) {}
	virtual FXbool doKeyDown(FXWindow* window, FXuint key, FXuint code) {return false;}
	virtual FXbool doKeyUp(FXWindow* window, FXuint key, FXuint code) {return false;}
	virtual FXbool doLButtonDown(FXWindow* window, FXint x, FXint y, FXbool bCtrl) {return false;}
	virtual FXbool doMouseMove(FXWindow* window, FXint x, FXint y) {return false;}
	virtual FXbool doLButtonUp(FXWindow* window, FXint x, FXint y) {return false;}

// Attributes
private:
	FXbool m_bAllowDelete;
	FXbool m_bCtrlPressed;
};

#endif // __CApp_H__
