/**************************************************************************
 *               This file is part of the FOX Dialog Editor               * 
 *                                                                        * 
 *      Copyright (C) 1999-2000 Martin Welch <mwelch@totalise.co.uk>      *
 *                                                                        * 
 *  This program is free software; you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *                  (at your option) any later version.                   *
 *                                                                        * 
 *    This program is distributed in the hope that it will be useful,     *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *             GNU General Public License for more details.               *
 *                                                                        * 
 *   You should have received a copy of the GNU General Public License    *
 *      along with this program; if not, write to the Free Software       *
 *       Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 **************************************************************************/

#ifndef __CFILE_H__
#define __CFILE_H__

class CFile : public ITextStream
{
// Services
public:
	CFile();
	virtual ~CFile();

// Properties
public:
	FXString name(void) {return m_szName;}

	FXbool isOpen(void) {return m_bOpen;}
	FXbool isClosed(void) {return !m_bOpen;}

// Operations
public:
	FXbool openRead(FXString& strFile, FXbool bEnd = FALSE);
	FXbool openRead(const char* pszFileName, FXbool bEnd = FALSE) {FXString s = pszFileName; return openRead(s, bEnd);}
	FXbool openWrite(FXString& strFile, FXbool bEnd = FALSE);
	FXbool openWrite(const char* pszFileName, FXbool bEnd = FALSE) {FXString s = pszFileName; return openWrite(s, bEnd);}

	void close(void);

	FXbool lineInput(FXString& strLine);
	FXbool write(FXString& strLine);

    ITextStream& operator<<(const FXString s);
    ITextStream& operator<<(const char c);
	ITextStream& operator<<(const FXint i);

// Attributes
private:
	FILE*  m_pFile;
	char   m_szName[512];
	FXbool m_bOpen;

	char m_buffer[1025];
	int  m_nMaxPos;
	int  m_nBufferLen;
	int  m_nPos;
	int  m_nScanPos;
};

#endif // __CFILE_H__
