/**************************************************************************
 *               This file is part of the FOX Dialog Editor               * 
 *                                                                        * 
 *      Copyright (C) 1999-2000 Martin Welch <mwelch@totalise.co.uk>      *
 *                                                                        * 
 *  This program is free software; you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *                  (at your option) any later version.                   *
 *                                                                        * 
 *    This program is distributed in the hope that it will be useful,     *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *             GNU General Public License for more details.               *
 *                                                                        * 
 *   You should have received a copy of the GNU General Public License    *
 *      along with this program; if not, write to the Free Software       *
 *       Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 **************************************************************************/

#ifndef __CDispenserScrollbar_H__
#define __CDispenserScrollbar_H__

class CDispenserVScrollbar : public CDispenser
{
public:
	CDispenserVScrollbar();

	virtual const char* getWidgetName(void);
	virtual const void* getWidgetIcon(void);
	virtual const char* getWidgetCategory(void);
	virtual const int   getWidgetGrabbers(void);

	virtual FXint getDefaultWidth(void);
	virtual FXint getDefaultHeight(void);
	virtual FXint getMinimumWidth(void);
	virtual FXint getMinimumHeight(void);
	virtual FXint getMaximumWidth(void);
	virtual FXint getMaximumHeight(void);

	virtual const FXMetaClass* getClassInfo(void);
	virtual FXbool canHaveChildren(void) {return FALSE;}
	virtual FXbool allowChild(const FXMetaClass* pChildClass);
	virtual FXbool allowParent(FXWindow* pParent);
	virtual FXWindow* getCreateParent(FXWindow* pParent);
	virtual FXbool IsValidWidget(FXWindow** ppWindow);

	virtual IDispenser* clone(void);
	virtual FXWindow* createWidget(FXComposite* p, FXObject* tgt=NULL, FXSelector sel=0);

	virtual FXString getChildSuffix(void) {return "";}
	virtual void getDefinitionCode(ITextStream& stream, FXWindow* pWidget, FXString& widget, FXString& parent) {}
	virtual void getImplementationCode(ITextStream& stream, FXWindow* pWidget, FXString& widget, FXString& parent);
};

class CDispenserHScrollbar : public CDispenser
{
public:
	CDispenserHScrollbar();

	virtual const char* getWidgetName(void);
	virtual const void* getWidgetIcon(void);
	virtual const char* getWidgetCategory(void);
	virtual const int   getWidgetGrabbers(void);

	virtual FXint getDefaultWidth(void);
	virtual FXint getDefaultHeight(void);
	virtual FXint getMinimumWidth(void);
	virtual FXint getMinimumHeight(void);
	virtual FXint getMaximumWidth(void);
	virtual FXint getMaximumHeight(void);

	virtual const FXMetaClass* getClassInfo(void);
	virtual FXbool canHaveChildren(void) {return FALSE;}
	virtual FXbool allowChild(const FXMetaClass* pChildClass);
	virtual FXbool allowParent(FXWindow* pParent);
	virtual FXWindow* getCreateParent(FXWindow* pParent);
	virtual FXbool IsValidWidget(FXWindow** ppWindow);

	virtual IDispenser* clone(void);
	virtual FXWindow* createWidget(FXComposite* p, FXObject* tgt=NULL, FXSelector sel=0);

	virtual FXString getChildSuffix(void) {return "";}
	virtual void getDefinitionCode(ITextStream& stream, FXWindow* pWidget, FXString& widget, FXString& parent) {}
	virtual void getImplementationCode(ITextStream& stream, FXWindow* pWidget, FXString& widget, FXString& parent);
};

#endif // __CDispenserScrollbar_H__
