/**************************************************************************  
 *               This file is part of the FOX Dialog Editor               * 
 *                                                                        * 
 *      Copyright (C) 1999-2000 Martin Welch <mwelch@totalise.co.uk>      *
 *                                                                        * 
 *  This program is free software; you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *                  (at your option) any later version.                   *
 *                                                                        * 
 *    This program is distributed in the hope that it will be useful,     *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *             GNU General Public License for more details.               *
 *                                                                        * 
 *   You should have received a copy of the GNU General Public License    *
 *      along with this program; if not, write to the Free Software       *
 *       Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 **************************************************************************/

#ifndef __CPropertyTitle_H__
#define __CPropertyTitle_H__

template <class T>
class CPropertyTitle : public CProperty
{
public:
	CPropertyTitle(IDispenser* pDispenser) : CProperty(pDispenser) {}

	const char* name(void);
	virtual ePropertyType type(void);
	virtual const char* description(void);
	virtual const char* tooltip(void);

	void set(FXWindow* pWindow, FXString strValue);
	FXString get(FXWindow* pWindow);
};

template <class T>
const char* CPropertyTitle<T>::name(void)
{
	return "Title";
}

template <class T>
ePropertyType CPropertyTitle<T>::type(void)
{
	return PROPERTY_TEXT;
}

template <class T>
const char* CPropertyTitle<T>::description(void)
{
	return "The text displayed in this object's\ntitle bar.";
}

template <class T>
const char* CPropertyTitle<T>::tooltip(void)
{
	return "getTitle()\nsetTitle()";
}

template <class T>
void CPropertyTitle<T>::set(FXWindow* pWindow, FXString strValue)
{
	CFrame* p = (CFrame*)pWindow;
	p->setTitle(strValue);
}

template <class T>
FXString CPropertyTitle<T>::get(FXWindow* pWindow)
{
	CFrame* p = (CFrame*)pWindow;

	return p->getTitle();
}

#endif // __CPropertyTitle_H__
