/**************************************************************************  
 *               This file is part of the FOX Dialog Editor               * 
 *                                                                        * 
 *      Copyright (C) 1999-2000 Martin Welch <mwelch@totalise.co.uk>      *
 *                                                                        * 
 *  This program is free software; you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *                  (at your option) any later version.                   *
 *                                                                        * 
 *    This program is distributed in the hope that it will be useful,     *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *             GNU General Public License for more details.               *
 *                                                                        * 
 *   You should have received a copy of the GNU General Public License    *
 *      along with this program; if not, write to the Free Software       *
 *       Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 **************************************************************************/

#ifndef __IConnector_H__
#define __IConnector_H__

struct IProperty;

struct IConnector
{
	virtual FXWindow* addWidget(FXWindow* pParent, FXbool bCreate, FXbool bSetCurrent = TRUE, FXshort x = 0, FXshort y = 0, FXshort w = 0, FXshort h = 0) = 0;
	virtual FXWindow* getWidget(void) = 0;

	virtual void select(FXbool bMultiple = FALSE) = 0;
	virtual void remove(void) = 0;
	virtual void releaseButtons(void) = 0;
	virtual void update(const FXchar* pszName) = 0;
	virtual void close(void) = 0;

	virtual void set(FXString strValue) = 0;
	virtual FXString get(void) = 0;

//	virtual FXbool getProperty(const FXchar* pszName, IProperty** ppProperty) = 0;
	virtual void refreshProperty(void) = 0;
};

#endif // __IConnector_H__